package LATMOS::Accounts::Web::Controller::Tools::LoadPasswd;
use Moose;
use namespace::autoclean;

use LATMOS::Accounts::Log;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Tools::LoadPasswd - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    my $account = $c->model('Accounts');

    if (my $upload = $c->req->upload('input')) {

        my $crypt = $c->req->param('crypt');
        my $force = $c->req->param('force');

        my $fh =  $upload->fh;
        while (my $line = <$fh>) {
            my ($username, $password) = split(/:/, $line);
            $username or next;
            $password or next;

            if ($crypt) {
                my $user = $account->db->get_objects('user', $username)
                    or do {
                    push(@{ $c->stash->{Pass} }, { u => $username, r => $c->localize('No such user') });
                    next;
                };
                $account->db->check_acl($user, 'userPassword', 'w')
                    or do {
                    push(@{ $c->stash->{Pass} }, { u => $username, r => $c->localize('Permission denied') });
                    next;
                };

                if ($user->InjectCryptPasswd($password)) {
                    push(@{ $c->stash->{Pass} }, { u => $username, r => $c->localize('Injected') };
                } else {
                    push(@{ $c->stash->{Pass} }, { u => $username, r => 'Error: ' . LATMOS::Accounts::Log::lastmessage(LA_ERR) });
                }
            } else {
                my $message = $account->ChangeUserPassword($username, $password, $force);
                push(@{ $c->stash->{Pass} }, { u => $username, r => $message || $c->localize('Changed') });
            }
        }
    }
}

=encoding utf8

=head1 AUTHOR

Olivier Thauvin,Guyancourt - B1428,+33 1 80285052,

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
